--- old/backup.c
+++ new/backup.c
@@ -23,6 +23,7 @@
 
 extern int verbose;
 extern int am_root;
+extern int preserve_acls;
 extern int preserve_devices;
 extern int preserve_specials;
 extern int preserve_links;
@@ -93,7 +94,8 @@ path
 ****************************************************************************/
 static int make_bak_dir(char *fullpath)
 {
-	STRUCT_STAT st;
+	statx sx;
+	struct file_struct *file;
 	char *rel = fullpath + backup_dir_len;
 	char *end = rel + strlen(rel);
 	char *p = end;
@@ -125,15 +127,24 @@ static int make_bak_dir(char *fullpath)
 		if (p >= rel) {
 			/* Try to transfer the directory settings of the
 			 * actual dir that the files are coming from. */
-			if (do_stat(rel, &st) < 0) {
+			if (do_stat(rel, &sx.st) < 0) {
 				rsyserr(FERROR, errno,
 					"make_bak_dir stat %s failed",
 					full_fname(rel));
 			} else {
-				do_lchown(fullpath, st.st_uid, st.st_gid);
-#ifdef HAVE_CHMOD
-				do_chmod(fullpath, st.st_mode);
+#ifdef SUPPORT_ACLS
+				sx.acc_acl = sx.def_acl = NULL;
+#endif
+				if (!(file = make_file(rel, NULL, NULL, 0, NO_FILTERS)))
+					continue;
+#ifdef SUPPORT_ACLS
+				if (preserve_acls) {
+					get_acl(rel, &sx);
+					cache_acl(file, &sx);
+				}
 #endif
+				set_file_attrs(fullpath, file, NULL, 0);
+				free(file);
 			}
 		}
 		*p = '/';
@@ -171,15 +182,18 @@ static int robust_move(const char *src, 
  * We will move the file to be deleted into a parallel directory tree. */
 static int keep_backup(const char *fname)
 {
-	STRUCT_STAT st;
+	statx sx;
 	struct file_struct *file;
 	char *buf;
 	int kept = 0;
 	int ret_code;
 
 	/* return if no file to keep */
-	if (do_lstat(fname, &st) < 0)
+	if (do_lstat(fname, &sx.st) < 0)
 		return 1;
+#ifdef SUPPORT_ACLS
+	sx.acc_acl = sx.def_acl = NULL;
+#endif
 
 	if (!(file = make_file(fname, NULL, NULL, 0, NO_FILTERS)))
 		return 1; /* the file could have disappeared */
@@ -189,6 +203,13 @@ static int keep_backup(const char *fname
 		return 0;
 	}
 
+#ifdef SUPPORT_ACLS
+	if (preserve_acls) {
+		get_acl(fname, &sx);
+		cache_acl(file, &sx);
+	}
+#endif
+
 	/* Check to see if this is a device file, or link */
 	if ((am_root && preserve_devices && IS_DEVICE(file->mode))
 	 || (preserve_specials && IS_SPECIAL(file->mode))) {
@@ -260,7 +281,7 @@ static int keep_backup(const char *fname
 		if (robust_move(fname, buf) != 0) {
 			rsyserr(FERROR, errno, "keep_backup failed: %s -> \"%s\"",
 				full_fname(fname), buf);
-		} else if (st.st_nlink > 1) {
+		} else if (sx.st.st_nlink > 1) {
 			/* If someone has hard-linked the file into the backup
 			 * dir, rename() might return success but do nothing! */
 			robust_unlink(fname); /* Just in case... */
--- old/compat.c
+++ new/compat.c
@@ -56,6 +56,8 @@ void setup_protocol(int f_out,int f_in)
 		preserve_uid = ++file_extra_cnt;
 	if (preserve_gid)
 		preserve_gid = ++file_extra_cnt;
+	if (preserve_acls && !am_sender)
+		preserve_acls = ++file_extra_cnt;
 
 	if (remote_protocol == 0) {
 		if (!read_batch)
--- old/configure.in
+++ new/configure.in
@@ -542,6 +542,11 @@ if test x"$ac_cv_func_strcasecmp" = x"no
     AC_CHECK_LIB(resolv, strcasecmp)
 fi
 
+AC_CHECK_FUNCS(aclsort)
+if test x"$ac_cv_func_aclsort" = x"no"; then
+    AC_CHECK_LIB(sec, aclsort)
+fi
+
 dnl At the moment we don't test for a broken memcmp(), because all we
 dnl need to do is test for equality, not comparison, and it seems that
 dnl every platform has a memcmp that can do at least that.
@@ -806,6 +811,78 @@ AC_SUBST(OBJ_RESTORE)
 AC_SUBST(CC_SHOBJ_FLAG)
 AC_SUBST(BUILD_POPT)
 
+AC_CHECK_HEADERS(sys/acl.h acl/libacl.h)
+AC_CHECK_FUNCS(_acl __acl _facl __facl)
+#################################################
+# check for ACL support
+
+AC_MSG_CHECKING(whether to support ACLs)
+AC_ARG_ENABLE(acl-support,
+AC_HELP_STRING([--enable-acl-support], [Include ACL support (default=no)]),
+[ case "$enableval" in
+  yes)
+
+		case "$host_os" in
+		*sysv5*)
+			AC_MSG_RESULT(Using UnixWare ACLs)
+			AC_DEFINE(HAVE_UNIXWARE_ACLS, 1, [true if you have UnixWare ACLs])
+			;;
+		*solaris*|*cygwin*)
+			AC_MSG_RESULT(Using solaris ACLs)
+			AC_DEFINE(HAVE_SOLARIS_ACLS, 1, [true if you have solaris ACLs])
+			;;
+		*hpux*)
+			AC_MSG_RESULT(Using HPUX ACLs)
+			AC_DEFINE(HAVE_HPUX_ACLS, 1, [true if you have HPUX ACLs])
+			;;
+		*irix*)
+			AC_MSG_RESULT(Using IRIX ACLs)
+			AC_DEFINE(HAVE_IRIX_ACLS, 1, [true if you have IRIX ACLs])
+			;;
+		*aix*)
+			AC_MSG_RESULT(Using AIX ACLs)
+			AC_DEFINE(HAVE_AIX_ACLS, 1, [true if you have AIX ACLs])
+			;;
+		*osf*)
+			AC_MSG_RESULT(Using Tru64 ACLs)
+			AC_DEFINE(HAVE_TRU64_ACLS, 1, [true if you have Tru64 ACLs])
+			LIBS="$LIBS -lpacl"
+			;;
+		*)
+		    AC_MSG_RESULT(ACLs requested -- running tests)
+		    AC_CHECK_LIB(acl,acl_get_file)
+			AC_CACHE_CHECK([for ACL support],samba_cv_HAVE_POSIX_ACLS,[
+			AC_TRY_LINK([#include <sys/types.h>
+#include <sys/acl.h>],
+[ acl_t acl; int entry_id; acl_entry_t *entry_p; return acl_get_entry( acl, entry_id, entry_p);],
+samba_cv_HAVE_POSIX_ACLS=yes,samba_cv_HAVE_POSIX_ACLS=no)])
+			AC_MSG_CHECKING(ACL test results)
+			if test x"$samba_cv_HAVE_POSIX_ACLS" = x"yes"; then
+			    AC_MSG_RESULT(Using posix ACLs)
+			    AC_DEFINE(HAVE_POSIX_ACLS, 1, [true if you have posix ACLs])
+			    AC_CACHE_CHECK([for acl_get_perm_np],samba_cv_HAVE_ACL_GET_PERM_NP,[
+				AC_TRY_LINK([#include <sys/types.h>
+#include <sys/acl.h>],
+[ acl_permset_t permset_d; acl_perm_t perm; return acl_get_perm_np( permset_d, perm);],
+samba_cv_HAVE_ACL_GET_PERM_NP=yes,samba_cv_HAVE_ACL_GET_PERM_NP=no)])
+			    if test x"$samba_cv_HAVE_ACL_GET_PERM_NP" = x"yes"; then
+				AC_DEFINE(HAVE_ACL_GET_PERM_NP, 1, [true if you have acl_get_perm_np])
+			    fi
+			else
+			    AC_MSG_ERROR(Failed to find ACL support)
+			fi
+			;;
+		esac
+		;;
+  *)
+    AC_MSG_RESULT(no)
+	AC_DEFINE(HAVE_NO_ACLS, 1, [true if you don't have ACLs])
+    ;;
+  esac ],
+  AC_DEFINE(HAVE_NO_ACLS, 1, [true if you don't have ACLs])
+  AC_MSG_RESULT(no)
+)
+
 AC_CONFIG_FILES([Makefile lib/dummy zlib/dummy popt/dummy shconfig])
 AC_OUTPUT
 
--- old/flist.c
+++ new/flist.c
@@ -42,6 +42,7 @@ extern int filesfrom_fd;
 extern int one_file_system;
 extern int copy_dirlinks;
 extern int keep_dirlinks;
+extern int preserve_acls;
 extern int preserve_links;
 extern int preserve_hard_links;
 extern int preserve_devices;
@@ -153,6 +154,8 @@ static void list_file_entry(struct file_
 	permstring(permbuf, f->mode);
 	len = F_LENGTH(f);
 
+	/* TODO: indicate '+' if the entry has an ACL. */
+
 #ifdef SUPPORT_LINKS
 	if (preserve_links && S_ISLNK(f->mode)) {
 		rprintf(FINFO, "%s %11.0f %s %s -> %s\n",
@@ -715,6 +718,12 @@ static struct file_struct *recv_file_ent
 	}
 #endif
 
+#ifdef SUPPORT_ACLS
+	/* We need one or two index int32s when we're preserving ACLs. */
+	if (preserve_acls)
+		extra_len += (S_ISDIR(mode) ? 2 : 1) * EXTRA_LEN;
+#endif
+
 	if (always_checksum && S_ISREG(mode))
 		extra_len += SUM_EXTRA_CNT * EXTRA_LEN;
 
@@ -852,6 +861,11 @@ static struct file_struct *recv_file_ent
 			read_buf(f, bp, checksum_len);
 	}
 
+#ifdef SUPPORT_ACLS
+	if (preserve_acls)
+		receive_acl(file, f);
+#endif
+
 	if (S_ISREG(mode) || S_ISLNK(mode))
 		stats.total_size += file_length;
 
@@ -1123,6 +1137,9 @@ static struct file_struct *send_file_nam
 					  int flags, int filter_flags)
 {
 	struct file_struct *file;
+#ifdef SUPPORT_ACLS
+	statx sx;
+#endif
 
 	file = make_file(fname, flist, stp, flags, filter_flags);
 	if (!file)
@@ -1131,12 +1148,26 @@ static struct file_struct *send_file_nam
 	if (chmod_modes && !S_ISLNK(file->mode))
 		file->mode = tweak_mode(file->mode, chmod_modes);
 
+#ifdef SUPPORT_ACLS
+	if (preserve_acls && f >= 0) {
+		sx.st.st_mode = file->mode;
+		sx.acc_acl = sx.def_acl = NULL;
+		if (get_acl(fname, &sx) < 0)
+			return NULL;
+	}
+#endif
+
 	maybe_emit_filelist_progress(flist->count + flist_count_offset);
 
 	flist_expand(flist);
 	flist->files[flist->count++] = file;
-	if (f >= 0)
+	if (f >= 0) {
 		send_file_entry(f, file, flist->count - 1);
+#ifdef SUPPORT_ACLS
+		if (preserve_acls)
+			send_acl(&sx, f);
+#endif
+	}
 	return file;
 }
 
